hdu 1087 Super Jumping! Jumping! Jumping!

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now. 



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path. 
Your task is to output the maximum value according to the given chessmen list. 

Input


Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N 
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int. 
A test case starting with 0 terminates the input and this test case is not to be processed. 

Output


For each case, print the maximum according to rules, and one line one case. 

Sample Input


3 1 3 2
4 1 2 3 4
4 3 3 2 1
0

Sample Output


4
10
3

很简单的一道题,求递增子序列的最大值。

一开始没读懂题,把子序列以为是子串就wa了。不过思想是一样的,用dp[i]储存到i的最大值。无非子序列要多套一个循环,dp[i]的值要取当前d[i]和小于i的j的dp值与i的和的较大值,因为要计算最优情况(这句话好多个的),不然形如3 2 5这样的输入就得不到正确答案。

AC代码:

#include <iostream>
#include <cstring>
#include <cmath>
using namespace std;

int main()
{
    int a[1010],dp[1010],n;
    while(cin>>n&&n)
    {
        memset(dp,0,sizeof(dp));
        for(int i=0;i<n;i++)
            cin>>a[i];
        dp[0]=a[0];
        int maxx=0;
        for(int i=1;i<n;i++)
        {
            for(int j=0;j<i;j++)
                if(a[j]<a[i])
                    dp[i]=max(dp[i],dp[j]+a[i]);
            dp[i]=max(dp[i],a[i]);
        }
        for(int i=0;i<n;i++)
            maxx=max(maxx,dp[i]);
        cout<<maxx<<endl;
    }
    return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值